<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for productAvailabilityDate StructType
 * @subpackage Structs
 */
class ProductAvailabilityDate extends AbstractStructBase
{
    /**
     * The duration
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $duration;
    /**
     * The dateBegin
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $dateBegin;
    /**
     * The dateEnd
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var string
     */
    public $dateEnd;
    /**
     * The TRUE_dateDiff
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $TRUE_dateDiff;
    /**
     * The ABS_dateDiff
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $ABS_dateDiff;
    /**
     * The stock
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $stock;
    /**
     * The txtFinalDates
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $txtFinalDates;
    /**
     * The dateBeginText
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $dateBeginText;
    /**
     * The dateEndText
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $dateEndText;
    /**
     * The searchAlternativeReason
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\SearchAlternativeReason
     */
    public $searchAlternativeReason;
    /**
     * Constructor method for productAvailabilityDate
     * @uses ProductAvailabilityDate::setDuration()
     * @uses ProductAvailabilityDate::setDateBegin()
     * @uses ProductAvailabilityDate::setDateEnd()
     * @uses ProductAvailabilityDate::setTRUE_dateDiff()
     * @uses ProductAvailabilityDate::setABS_dateDiff()
     * @uses ProductAvailabilityDate::setStock()
     * @uses ProductAvailabilityDate::setTxtFinalDates()
     * @uses ProductAvailabilityDate::setDateBeginText()
     * @uses ProductAvailabilityDate::setDateEndText()
     * @uses ProductAvailabilityDate::setSearchAlternativeReason()
     * @param int $duration
     * @param string $dateBegin
     * @param string $dateEnd
     * @param int $tRUE_dateDiff
     * @param int $aBS_dateDiff
     * @param int $stock
     * @param string $txtFinalDates
     * @param string $dateBeginText
     * @param string $dateEndText
     * @param \StructType\SearchAlternativeReason $searchAlternativeReason
     */
    public function __construct($duration = null, $dateBegin = null, $dateEnd = null, $tRUE_dateDiff = null, $aBS_dateDiff = null, $stock = null, $txtFinalDates = null, $dateBeginText = null, $dateEndText = null, \StructType\SearchAlternativeReason $searchAlternativeReason = null)
    {
        $this
            ->setDuration($duration)
            ->setDateBegin($dateBegin)
            ->setDateEnd($dateEnd)
            ->setTRUE_dateDiff($tRUE_dateDiff)
            ->setABS_dateDiff($aBS_dateDiff)
            ->setStock($stock)
            ->setTxtFinalDates($txtFinalDates)
            ->setDateBeginText($dateBeginText)
            ->setDateEndText($dateEndText)
            ->setSearchAlternativeReason($searchAlternativeReason);
    }
    /**
     * Get duration value
     * @return int
     */
    public function getDuration()
    {
        return $this->duration;
    }
    /**
     * Set duration value
     * @param int $duration
     * @return \StructType\ProductAvailabilityDate
     */
    public function setDuration($duration = null)
    {
        // validation for constraint: int
        if (!is_null($duration) && !(is_int($duration) || ctype_digit($duration))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($duration, true), gettype($duration)), __LINE__);
        }
        $this->duration = $duration;
        return $this;
    }
    /**
     * Get dateBegin value
     * @return string
     */
    public function getDateBegin()
    {
        return $this->dateBegin;
    }
    /**
     * Set dateBegin value
     * @param string $dateBegin
     * @return \StructType\ProductAvailabilityDate
     */
    public function setDateBegin($dateBegin = null)
    {
        // validation for constraint: string
        if (!is_null($dateBegin) && !is_string($dateBegin)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dateBegin, true), gettype($dateBegin)), __LINE__);
        }
        $this->dateBegin = $dateBegin;
        return $this;
    }
    /**
     * Get dateEnd value
     * @return string
     */
    public function getDateEnd()
    {
        return $this->dateEnd;
    }
    /**
     * Set dateEnd value
     * @param string $dateEnd
     * @return \StructType\ProductAvailabilityDate
     */
    public function setDateEnd($dateEnd = null)
    {
        // validation for constraint: string
        if (!is_null($dateEnd) && !is_string($dateEnd)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dateEnd, true), gettype($dateEnd)), __LINE__);
        }
        $this->dateEnd = $dateEnd;
        return $this;
    }
    /**
     * Get TRUE_dateDiff value
     * @return int
     */
    public function getTRUE_dateDiff()
    {
        return $this->TRUE_dateDiff;
    }
    /**
     * Set TRUE_dateDiff value
     * @param int $tRUE_dateDiff
     * @return \StructType\ProductAvailabilityDate
     */
    public function setTRUE_dateDiff($tRUE_dateDiff = null)
    {
        // validation for constraint: int
        if (!is_null($tRUE_dateDiff) && !(is_int($tRUE_dateDiff) || ctype_digit($tRUE_dateDiff))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($tRUE_dateDiff, true), gettype($tRUE_dateDiff)), __LINE__);
        }
        $this->TRUE_dateDiff = $tRUE_dateDiff;
        return $this;
    }
    /**
     * Get ABS_dateDiff value
     * @return int
     */
    public function getABS_dateDiff()
    {
        return $this->ABS_dateDiff;
    }
    /**
     * Set ABS_dateDiff value
     * @param int $aBS_dateDiff
     * @return \StructType\ProductAvailabilityDate
     */
    public function setABS_dateDiff($aBS_dateDiff = null)
    {
        // validation for constraint: int
        if (!is_null($aBS_dateDiff) && !(is_int($aBS_dateDiff) || ctype_digit($aBS_dateDiff))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($aBS_dateDiff, true), gettype($aBS_dateDiff)), __LINE__);
        }
        $this->ABS_dateDiff = $aBS_dateDiff;
        return $this;
    }
    /**
     * Get stock value
     * @return int
     */
    public function getStock()
    {
        return $this->stock;
    }
    /**
     * Set stock value
     * @param int $stock
     * @return \StructType\ProductAvailabilityDate
     */
    public function setStock($stock = null)
    {
        // validation for constraint: int
        if (!is_null($stock) && !(is_int($stock) || ctype_digit($stock))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($stock, true), gettype($stock)), __LINE__);
        }
        $this->stock = $stock;
        return $this;
    }
    /**
     * Get txtFinalDates value
     * @return string|null
     */
    public function getTxtFinalDates()
    {
        return $this->txtFinalDates;
    }
    /**
     * Set txtFinalDates value
     * @param string $txtFinalDates
     * @return \StructType\ProductAvailabilityDate
     */
    public function setTxtFinalDates($txtFinalDates = null)
    {
        // validation for constraint: string
        if (!is_null($txtFinalDates) && !is_string($txtFinalDates)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($txtFinalDates, true), gettype($txtFinalDates)), __LINE__);
        }
        $this->txtFinalDates = $txtFinalDates;
        return $this;
    }
    /**
     * Get dateBeginText value
     * @return string|null
     */
    public function getDateBeginText()
    {
        return $this->dateBeginText;
    }
    /**
     * Set dateBeginText value
     * @param string $dateBeginText
     * @return \StructType\ProductAvailabilityDate
     */
    public function setDateBeginText($dateBeginText = null)
    {
        // validation for constraint: string
        if (!is_null($dateBeginText) && !is_string($dateBeginText)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dateBeginText, true), gettype($dateBeginText)), __LINE__);
        }
        $this->dateBeginText = $dateBeginText;
        return $this;
    }
    /**
     * Get dateEndText value
     * @return string|null
     */
    public function getDateEndText()
    {
        return $this->dateEndText;
    }
    /**
     * Set dateEndText value
     * @param string $dateEndText
     * @return \StructType\ProductAvailabilityDate
     */
    public function setDateEndText($dateEndText = null)
    {
        // validation for constraint: string
        if (!is_null($dateEndText) && !is_string($dateEndText)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($dateEndText, true), gettype($dateEndText)), __LINE__);
        }
        $this->dateEndText = $dateEndText;
        return $this;
    }
    /**
     * Get searchAlternativeReason value
     * @return \StructType\SearchAlternativeReason|null
     */
    public function getSearchAlternativeReason()
    {
        return $this->searchAlternativeReason;
    }
    /**
     * Set searchAlternativeReason value
     * @param \StructType\SearchAlternativeReason $searchAlternativeReason
     * @return \StructType\ProductAvailabilityDate
     */
    public function setSearchAlternativeReason(\StructType\SearchAlternativeReason $searchAlternativeReason = null)
    {
        $this->searchAlternativeReason = $searchAlternativeReason;
        return $this;
    }
}
